Categories added to Pi-Apps!

pull/233/head
Botspot 4 years ago
parent 1a12fc21c8
commit 6a8f54a535

@ -0,0 +1,91 @@
#!/bin/bash
DIRECTORY="$(readlink -f "$(dirname "$(dirname "$0")")")"
function error {
echo -e "\e[91m$1\e[39m"
exit 1
}
APPS="$(ls "${DIRECTORY}/apps")"
refresh() {
structure="$(cat "${DIRECTORY}/data/categories/structure")"
}
refresh
#command line argument handler
if [ ! -z "$1" ] && [ ! -z "$2" ];then
if ! echo "$APPS" | grep -q "$1" ;then
error "The $1 app does not exist in ${DIRECTORY}/apps!"
fi
if echo "$structure" | grep -q "$1"'|' ;then
echo "The $1 app is currently in the $(dirname "$(echo "$structure" | grep "$1"'|' | awk -F '|' '{print $2}')") category."
fi
if ! echo "$structure" | grep -q "$2"'/' ;then
echo "The $2 category did not exist previously."
fi
echo "Putting the $1 app in the $2 category..."
#replace any mention of the $1 app with the new line at the end of file
echo -e "$(echo "$structure" | grep -v "$1"'|')\n$1|$2" > "${DIRECTORY}/data/categories/structure"
#structure file modified. Refresh the variable
refresh
echo "Line in structure file: $(echo "$structure" | grep "$1"'|')"
exit 0
fi
while true;do
#generate a virtual file system with apps in folders represented as subdirectories
PREIFS="$IFS"
IFS=$'\n'
LIST=''
for app in $APPS
do
category="$(echo "$structure" | grep "$app"'|' | awk -F '|' '{print $2}' | tr -d '.' | head -n1)"
#echo "category for $app is $category."
LIST="${LIST}${DIRECTORY}/apps/$app/icon-24.png
$app
$category
"
done
IFS="$PREIFS"
LIST="${LIST::-1}"
#echo -e "'$LIST'\n'$APPS'"
output="$(echo -e "$LIST" | yad --center --title='Category editor' --height=400 \
--list --text="Category file: $(echo "${DIRECTORY}/data/categories/structure" | sed 's+/home/pi+~+g')" --editable --editable-cols=3 --multiple --dclick-action=true --print-all \
--separator='|' --window-icon="${DIRECTORY}/icons/logo.png" \
--column=:IMG --column=Name --column=Category:TEXT \
--button=Reset!"${DIRECTORY}/icons/backup.png"!"Overwrites your structure file with the default one from the Pi-Apps repository.":4 \
--button=All!"${DIRECTORY}/icons/trash.png"!"Clears categories so all apps are in one list.":2 \
--button=Cancel!"${DIRECTORY}/icons/exit.png":1 \
--button=Save!"${DIRECTORY}/icons/check.png":0 )"
button=$?
if [ "$button" == 0 ];then
#save
break
elif [ "$button" == 2 ];then
#delete all
# remove categories from all lines, while leaving hidden ones intact
echo -e "$(echo "$structure" | grep -v '|hidden' | sed 's/|.*/|/')\n$(echo "$structure" | grep '|hidden')" | sort > "${DIRECTORY}/data/categories/structure"
elif [ "$button" == 4 ];then
#reset
rm "${DIRECTORY}/data/categories/structure"
wget -qO "${DIRECTORY}/data/categories/structure" 'https://raw.githubusercontent.com/Botspot/pi-apps/master/data/categories/structure'
[ ! -f "${DIRECTORY}/data/categories/structure" ] || [ -z "$(cat "${DIRECTORY}/data/categories/structure")" ] && error 'Failed to download a fresh structure file!'
else
#cancel or WM X
echo "User exited"
exit 0
fi
refresh
done
#remove first and last characters from each line ---- and '(null)' messaged from yad
output="$(echo "$output" | sed 's/.$//; s/^.//' | sed "s+(null)++g")"
echo "$output" > "${DIRECTORY}/data/categories/structure"
"${DIRECTORY}/etc/preload-daemon" yad once &

@ -0,0 +1,32 @@
#!/bin/bash
#runs in the background and refreshes all the list files
DIRECTORY="$(dirname "$(readlink -f "$(dirname "$0")")")"
function error {
echo -e "\e[91m$1\e[39m"
exit 1
}
#variable 1 is yad or xlunch
#variable 2 is 'once', if you only want this to run once and exit.
if [ "$(ps aux | grep preload-daemon | wc -l)" -gt 3 ];then
echo "Another instance of preload-daemon is already running. Exiting now."
exit 0
fi
folders="$(cat ${DIRECTORY}/data/categories/structure | awk -F '|' '{print $2}' | sort | uniq | grep .)"
echo "$folders"
#runs every 30 secs for 10 mins
for i in {1.."$([ "$2" == 'once' ] && echo '1' || echo '20')"};do
IFS=$'\n'
"${DIRECTORY}/preload" "$1" &>/dev/null
for folder in $folders ; do
"${DIRECTORY}/preload" "$1" "$folder" &>/dev/null
done
[ "$2" == 'once' ] && exit 0
sleep 30
done

132
gui

@ -17,20 +17,17 @@ if [ ! -z "$1" ];then
fi fi
#hide Chromium Widevine & Back to Chromium v78 on existing TwisterOS installs #hide Chromium Widevine & Back to Chromium v78 on existing TwisterOS installs
(if [ -f /usr/local/bin/twistver ] && [ -z "$(cat "${DIRECTORY}/data/hidelist" | grep "Lightpad")" ];then if [ -f "${DIRECTORY}/data/hidelist" ] || [ ! -d "${DIRECTORY}/data/categories" ];then
"${DIRECTORY}/install" "${DIRECTORY}/install"
rm "${DIRECTORY}/data/hidelist"
fi fi
#prettify hidelist file
hidelist="$(cat "${DIRECTORY}/data/hidelist" | sort | uniq | sed '/^[[:space:]]*$/d')"
echo "$hidelist" > "${DIRECTORY}/data/hidelist"
) &
#rename 'Vivaldi web browser' to Vivaldi #rename 'Vivaldi web browser' to Vivaldi
(find "$DIRECTORY" -name 'Vivaldi '* | while read f; do mv -v "$f" "$(echo "${f}" | sed 's/ web browser//g')"; done #(find "$DIRECTORY" -name 'Vivaldi '* | while read f; do mv -v "$f" "$(echo "${f}" | sed 's/ web browser//g')"; done
if [ ! -z "$(cat "$DIRECTORY/data/preload/LIST" | grep 'Vivaldi web browser')" ];then #if [ ! -z "$(cat "$DIRECTORY/data/preload/LIST" | grep 'Vivaldi web browser')" ];then
rm -rf "$DIRECTORY/data/preload" # rm -rf "$DIRECTORY/data/preload"
fi #fi
) & #) &
(if cat ~/.config/autostart/pi-apps-updater.desktop | grep -q installedonly ;then (if cat ~/.config/autostart/pi-apps-updater.desktop | grep -q installedonly ;then
"${DIRECTORY}/install" "${DIRECTORY}/install"
@ -93,8 +90,10 @@ guimode="$(cat "${DIRECTORY}/data/settings/App List Style")"
[ -z "$guimode" ] && guimode=yad [ -z "$guimode" ] && guimode=yad
#mode=yad #mode=yad
prefix=''
while true;do while true;do
LIST="$("${DIRECTORY}/preload" $guimode)" LIST="$("${DIRECTORY}/preload" $guimode $prefix)"
#LIST="$(cat "${DIRECTORY}/data/preload/LIST")" #LIST="$(cat "${DIRECTORY}/data/preload/LIST")"
#echo "$LIST" #echo "$LIST"
@ -103,14 +102,24 @@ while true;do
while [ -z "$output" ];do while [ -z "$output" ];do
if [ $guimode == yad ];then if [ "$guimode" == yad ];then
output="$(echo -e "$LIST" | yad --center --title='Pi-Apps' --width=310 --height=400 --no-headers \ if [ -z "$prefix" ];then
--text="$motd" --image="${DIRECTORY}/icons/logo-64.png" --image-on-top \ buttons=("--button=Install!${DIRECTORY}/icons/install.png:4" \
"--button=Uninstall!${DIRECTORY}/icons/uninstall.png:2" \
"--button=Details!${DIRECTORY}/icons/info.png!View more about the selected software:0" )
else
buttons=("--button=!${DIRECTORY}/icons/back.png!Back:3" \
"--button=!${DIRECTORY}/icons/install.png!Install:4" \
"--button=!${DIRECTORY}/icons/uninstall.png!Uninstall:2" \
"--button=!${DIRECTORY}/icons/info.png!Details:0" )
fi
output="$(echo -e "$LIST" | yad --center --title='Pi-Apps'"$([ ! -z "$prefix" ] && echo ": $(echo "$prefix" | tr '/' '>')")" --width=310 --height=400 --no-headers \
--text="$([ -z "$prefix" ] && echo "$motd" || echo "Viewing $(echo "$prefix" | tr '/' '>') category")" --image="${DIRECTORY}/icons/logo-64.png" --image-on-top \
--list --multiple --separator='\n' --window-icon="${DIRECTORY}/icons/logo.png" \ --list --multiple --separator='\n' --window-icon="${DIRECTORY}/icons/logo.png" \
--column=:IMG --column=:IMG --column=Name --column=tip:HD --print-column=3 --tooltip-column=4 \ --column=:IMG --column=:IMG --column=Name --column=Sysname:HD --column=tip:HD \
--button=Install!"${DIRECTORY}/icons/install.png":4 \ --print-column=4 --tooltip-column=5 \
--button=Uninstall!"${DIRECTORY}/icons/uninstall.png":2 \ "${buttons[@]}" \
--button=Details!"${DIRECTORY}/icons/info.png"!'View more about the selected software:0' \
)" )"
button=$? #get exit code to determine which button was pressed button=$? #get exit code to determine which button was pressed
@ -118,6 +127,10 @@ while true;do
if [ $button -eq 252 ];then #if window manager x was pressed if [ $button -eq 252 ];then #if window manager x was pressed
exit 0 exit 0
fi fi
if [ "$button" == 3 ];then
#back button
break
fi
if [ -z "$output" ];then if [ -z "$output" ];then
echo "output variable empty!" echo "output variable empty!"
yad --center --title='Pi-Apps' --width=310 \ yad --center --title='Pi-Apps' --width=310 \
@ -126,7 +139,8 @@ while true;do
(You didn"\'"t select an App)" \ (You didn"\'"t select an App)" \
--button=OK:0 --button=OK:0
fi fi
elif [ $guimode == xlunch ];then
elif [ "$guimode" == xlunch ];then
if [ ! -d "${DIRECTORY}/xlunch" ] || [ ! -f /usr/bin/xlunch ];then if [ ! -d "${DIRECTORY}/xlunch" ] || [ ! -f /usr/bin/xlunch ];then
sudo rm -rf /usr/bin/xlunch "$DIRECTORY/xlunch" 2>/dev/null sudo rm -rf /usr/bin/xlunch "$DIRECTORY/xlunch" 2>/dev/null
sudo apt install -y libimlib2-dev libx11-dev sudo apt install -y libimlib2-dev libx11-dev
@ -141,33 +155,54 @@ while true;do
error "xlunch should be installed now, but /usr/bin/xlunch does not exist!" error "xlunch should be installed now, but /usr/bin/xlunch does not exist!"
fi fi
fi fi
#xlunch compiled
screen_width="$(xdpyinfo | grep 'dimensions:' | tr 'x' '\n' | tr ' ' '\n' | sed -n 7p)" screen_width="$(xdpyinfo | grep 'dimensions:' | tr 'x' '\n' | tr ' ' '\n' | sed -n 7p)"
screen_height="$(xdpyinfo | grep 'dimensions:' | tr 'x' '\n' | tr ' ' '\n' | sed -n 8p)" screen_height="$(xdpyinfo | grep 'dimensions:' | tr 'x' '\n' | tr ' ' '\n' | sed -n 8p)"
height=700 height=700
width=800 width=800
xposition=$(((screen_width/2)-(width/2))) xposition=$(((screen_width/2)-(width/2)))
yposition=$(((screen_height/2)-(height/2))) yposition=$(((screen_height/2)-(height/2)))
if false;then if false;then
scrot -a "$((xposition+1)),$((yposition+33)),${width},${height}" blur.png #blur_init.png scrot -a "$((xposition+1)),$((yposition+33)),${width},${height}" blur.png #blur_init.png
convert -blur 10x5 ~/blur.png ~/blur.png convert -blur 10x5 ~/blur.png ~/blur.png
fi fi
if [ ! -z "$prefix" ];then
echo "Adding back button to xlunch..."
LIST="Back;${DIRECTORY}/icons/back-64.png;./
$LIST"
LIST="$(echo "$LIST" | grep .)"
fi
echo "$LIST"
if [ -z "$prefix" ];then
searchbox="Search: "
else
searchbox="Viewing $(echo "$prefix" | tr '/' '>'). Search: "
fi
output="$(echo -e "$LIST" | xlunch -WoCS -s 64 --bc 000000A0 --tc ffffffff --pc 6060ffff --hc 60606010 \ output="$(echo -e "$LIST" | xlunch -WoCS -s 64 --bc 000000A0 --tc ffffffff --pc 6060ffff --hc 60606010 \
-p "Search: " -a -c 2 --title "Pi-Apps: Raspberry Pi app store" \ -p "$searchbox" -a -c 2 --title "Pi-Apps: Raspberry Pi app store" \
--icon "${DIRECTORY}/icons/logo.png" --scrollbarcolor ffffff40 --scrollindicatorcolor 0000ff80\ --icon "${DIRECTORY}/icons/logo.png" --scrollbarcolor ffffff40 --scrollindicatorcolor 0000ff80\
--width $width --height $height --xposition $xposition --yposition $yposition \ --width $width --height $height --xposition $xposition --yposition $yposition \
--button "${DIRECTORY}/icons/logo-128.png;;$((($width/2)-(128/2))),0;" --button "${DIRECTORY}/icons/logo-128.png;;$((($width/2)-(128/2))),0;"
-g ~/blur.png)" #-g ~/blur.png
)"
button=0 button=0
if [ -z "$output" ];then if [ -z "$output" ];then
exit 0 error "xlunch did not report any selected apps!"
fi fi
else
error "Unrecognized app list style '$guimode'!"
fi fi
output="$(echo "$output" | sed '/^$/d')" output="$(echo "$output" | sed '/^$/d')"
echo "Output: ${output}EOO" echo "Output: ${output}EOO"
done done
#output variable populated
case $button in case $button in
@ -175,8 +210,27 @@ while true;do
echo "User exited." echo "User exited."
exit 0 exit 0
;; ;;
3)
echo "Back"
prefix="$(dirname "$prefix" | tr -d '.')"
;;
0) 0)
echo "Details" echo "Details"
if echo "$output" | grep -q '/' ;then
#folder
if [ "$output" == './' ];then
echo "Back"
prefix="$(dirname "$prefix" | tr -d '.')"
else
prefix="$prefix/$output"
prefix="${prefix::-1}"
prefix="$(echo "$prefix" | sed 's+^/++')"
fi
echo "Prefix is $prefix"
output=''
else
#app
output="$(echo "$output" | head -n1)" output="$(echo "$output" | head -n1)"
if [ ! -z "$(cat "${DIRECTORY}/data/installed-packages/${output}")" ];then if [ ! -z "$(cat "${DIRECTORY}/data/installed-packages/${output}")" ];then
installedpackages=" installedpackages="
@ -214,10 +268,10 @@ $installedpackages"
echo "$text" | yad --text-info --fontname=12 --wrap --show-uri \ echo "$text" | yad --text-info --fontname=12 --wrap --show-uri \
--image="${DIRECTORY}/apps/${output}/icon-64.png" --image-on-top \ --image="${DIRECTORY}/apps/${output}/icon-64.png" --image-on-top \
--title="Details of ${output}" --window-icon="${DIRECTORY}/icons/logo.png" --center --width=700 --height=300 \ --title="Details of ${output}" --window-icon="${DIRECTORY}/icons/logo.png" --center --width=700 --height=300 \
$whichbutton \ --button=Back!"${DIRECTORY}/icons/back.png":0 \
--button=''!"${DIRECTORY}/icons/up.png"!'View previous App':6 \ --button=''!"${DIRECTORY}/icons/up.png"!'View previous App':6 \
--button=''!"${DIRECTORY}/icons/down.png"!'View next App':8 \ --button=''!"${DIRECTORY}/icons/down.png"!'View next App':8 \
--button=Back!"${DIRECTORY}/icons/back.png":0 $whichbutton
button=$? #get exit code to determine which button was pressed button=$? #get exit code to determine which button was pressed
echo "Button: ${button}" echo "Button: ${button}"
@ -231,13 +285,15 @@ $installedpackages"
elif [ $button == 2 ];then elif [ $button == 2 ];then
app="$output" app="$output"
uninstall "$app" uninstall "$app"
elif [ $button == 6 ];then elif [ $button == 6 ] || [ $button == 8 ];then
#previous or next app clicked
lsoutput="$(echo "$LIST" | grep -v '/' | grep -v '(' | grep -v *'\n App folder' | awk -F ';' '{print $NF}' | uniq)"
echo "$lsoutput"
if [ $button == 6 ];then
echo 'previous app' echo 'previous app'
#convert $output into number, then subtract 1 from it #convert $output into number, then subtract 1 from it
lsoutput="$(echo "$(ls "${DIRECTORY}/apps")" | grep -vxE "$(cat "${DIRECTORY}/data/hidelist" | tr '\n' '|')")"
number="$(echo "$lsoutput" | grep -nx "$output" | cut -f1 -d: )" number="$(echo "$lsoutput" | grep -nx "$output" | cut -f1 -d: )"
lastline="$(echo "$lsoutput" | wc -l)" lastline="$(echo "$lsoutput" | wc -l)"
@ -251,14 +307,10 @@ $installedpackages"
output="$(echo "$lsoutput" | sed -n "${newnumber}p")" output="$(echo "$lsoutput" | sed -n "${newnumber}p")"
echo "Line number was ${number}, but now is ${newnumber}. Name is ${output}." echo "Line number was ${number}, but now is ${newnumber}. Name is ${output}."
elif [ $button == 8 ];then elif [ $button == 8 ];then
echo 'next app' echo 'next app'
#convert $output into number, then add 1 to it #convert $output into number, then add 1 to it
lsoutput="$(echo "$(ls "${DIRECTORY}/apps")" | grep -vxE "$(cat "${DIRECTORY}/data/hidelist" | tr '\n' '|')")"
number="$(echo "$lsoutput" | grep -nx "$output" | cut -f1 -d: )" number="$(echo "$lsoutput" | grep -nx "$output" | cut -f1 -d: )"
echo "Line number was ${number}, but now is ${newnumber}. Name is ${output}." echo "Line number was ${number}, but now is ${newnumber}. Name is ${output}."
@ -274,6 +326,7 @@ $installedpackages"
output="$(echo "$lsoutput" | sed -n "${newnumber}p")" output="$(echo "$lsoutput" | sed -n "${newnumber}p")"
echo "Line number was ${number}, but now is ${newnumber}. Name is ${output}." echo "Line number was ${number}, but now is ${newnumber}. Name is ${output}."
fi
elif [ $button == 10 ];then elif [ $button == 10 ];then
echo "edit $output" echo "edit $output"
"${DIRECTORY}/createapp" "$output" "${DIRECTORY}/createapp" "$output"
@ -281,15 +334,28 @@ $installedpackages"
echo 'unknown button. Exiting now.' echo 'unknown button. Exiting now.'
exit 0 exit 0
fi fi
fi
;; ;;
2) 2)
#uninstal
if ! echo "$output" | grep -q '/' ;then
uninstall "$output" uninstall "$output"
#clear output var to prompt main window to open next #clear output var to prompt main window to open next
else
motd="Sorry, you can"\'"t uninstall folders."
prefix=''
fi
output='' output=''
;; ;;
4) 4)
#install
if ! echo "$output" | grep -q '/' ;then
install "$output" install "$output"
#clear output var to prompt main window to open next #clear output var to prompt main window to open next
else
motd="Sorry, you can"\'"t install folders."
prefix=''
fi
output='' output=''
;; ;;
*) *)

@ -7,7 +7,7 @@ function error {
DIRECTORY="$(readlink -f "$(dirname "$0")")" DIRECTORY="$(readlink -f "$(dirname "$0")")"
if [ -z "$(dpkg-query -W --showformat='${Status}\n' yad 2>/dev/null | grep "install ok installed")" ];then if ! command -v yad >/dev/null;then
echo -n "YAD is required but not installed. Install now? [Y/n] " echo -n "YAD is required but not installed. Install now? [Y/n] "
read answer read answer
if [ "$answer" == n ];then if [ "$answer" == n ];then
@ -18,6 +18,8 @@ if [ -z "$(dpkg-query -W --showformat='${Status}\n' yad 2>/dev/null | grep "inst
sudo apt install -y yad sudo apt install -y yad
elif [ -f /usr/bin/pacman ];then elif [ -f /usr/bin/pacman ];then
sudo pacman -S yad sudo pacman -S yad
else
error "Failed to find any package manager"
fi fi
fi fi
@ -36,7 +38,7 @@ Type=Application
Categories=Utility;" > ~/.local/share/applications/pi-apps.desktop Categories=Utility;" > ~/.local/share/applications/pi-apps.desktop
echo "Adding Desktop shortcut..." echo "Adding Desktop shortcut..."
cp -f ${HOME}/.local/share/applications/pi-apps.desktop ${HOME}/Desktop/pi-apps.desktop cp -f ~/.local/share/applications/pi-apps.desktop ~/Desktop/pi-apps.desktop
echo "Creating Settings menu button..." echo "Creating Settings menu button..."
echo "[Desktop Entry] echo "[Desktop Entry]
@ -62,7 +64,7 @@ NoDisplay=false" > ~/.config/autostart/pi-apps-updater.desktop
mkdir -p "${DIRECTORY}/data" mkdir -p "${DIRECTORY}/data"
cd "${DIRECTORY}/data" cd "${DIRECTORY}/data"
mkdir -p installed-packages preload settings status update-status mkdir -p installed-packages preload settings status update-status categories
cd $HOME cd $HOME
#hide template file by default #hide template file by default
@ -70,7 +72,9 @@ echo "template" > "${DIRECTORY}/data/hidelist"
#hide duplicates if running in twisteros #hide duplicates if running in twisteros
if [ -f /usr/local/bin/twistver ];then if [ -f /usr/local/bin/twistver ];then
echo "BalenaEtcher PREIFS="$IFS"
IFS=$'\n'
apps="BalenaEtcher
Chromium Media Edition Chromium Media Edition
CommanderPi CommanderPi
Box86 Box86
@ -78,10 +82,15 @@ Discord
piKiss piKiss
Retropie Retropie
Scrcpy Scrcpy
Steam
Windows 10 Theme Windows 10 Theme
Chromium Widevine Chromium Widevine
Back to Chromium v78 Back to Chromium v78
Lightpad" >> "${DIRECTORY}/data/hidelist" Lightpad"
for app in $apps ;do
"${DIRECTORY}/etc/categoryedit" "$app" 'hidden'
done
echo "Finished hiding apps on TwisterOS."
fi fi
echo "Creating settings if they don"\'"t exist..." echo "Creating settings if they don"\'"t exist..."

@ -26,13 +26,21 @@ if [ -z "$format" ];then
format=yad format=yad
fi fi
#specifies an app folder(s)
prefix="$2"
timestampfile="${DIRECTORY}/data/preload/timestamps-$(echo "$prefix" | tr -d '/')"
listfile="${DIRECTORY}/data/preload/LIST-$(echo "$prefix" | tr -d '/')"
mkdir -p "${DIRECTORY}/data/preload" mkdir -p "${DIRECTORY}/data/preload"
mktimestamps() { mktimestamps() {
#these directories are checked for changes #these directories are checked for changes
checkdirs="${DIRECTORY}/apps checkdirs="${DIRECTORY}/apps
${DIRECTORY}/data/settings ${DIRECTORY}/data/settings
${DIRECTORY}/data/status" ${DIRECTORY}/data/status
${DIRECTORY}/data/categories
${DIRECTORY}/etc"
timestamps='' timestamps=''
PREIFS="$IFS" PREIFS="$IFS"
@ -45,16 +53,19 @@ $(stat -c %Y "${dir}/$(ls -t "$dir" | head -n1)")"
done done
IFS="$PREIFS" IFS="$PREIFS"
#remove first empty newline #remove first empty newline
timestamps="${timestamps:1}" timestamps="$prefix
$format
$(ls -1q "${DIRECTORY}/apps"/* | wc -l)
${timestamps:1}"
} }
reloadlist=0 reloadlist=0
if [ -f "${DIRECTORY}/data/preload/timestamps" ];then if [ -f "$timestampfile" ];then
#get modified timestamps for directories #get modified timestamps for directories
mktimestamps mktimestamps
if [ "$timestamps" == "$(cat "${DIRECTORY}/data/preload/timestamps")" ];then if [ "$timestamps" == "$(cat "$timestampfile")" ];then
#if current timestamps and saved timestamps match, then don't reload the list #if current timestamps and saved timestamps match, then don't reload the list
reloadlist=0 reloadlist=0
echo "Timestamps match." 1>&2 echo "Timestamps match." 1>&2
@ -68,17 +79,75 @@ else
reloadlist=1 reloadlist=1
fi fi
if [ ! -f "${DIRECTORY}/data/preload/LIST" ];then if [ ! -f "$listfile" ] || [ -z "$(cat "$listfile")" ];then
echo "list file does not exist." 1>&2 echo "list file does not exist." 1>&2
reloadlist=1 reloadlist=1
fi fi
#this ensures that all apps & categories stay preloaded.
(sleep 5;"${DIRECTORY}/etc/preload-daemon" "$format") 1>&2 &
if [ $reloadlist == 1 ];then if [ $reloadlist == 1 ];then
echo "Generating list..." 1>&2 echo "Generating list..." 1>&2
#get list of apps ----------------------------------- and exclude apps mentioned in hidelist file
APPS="$(echo "$(ls "${DIRECTORY}/apps")" | grep -vxE "$(cat "${DIRECTORY}/data/hidelist" | tr '\n' '|')")"
#APPS="$(echo "$(ls "${DIRECTORY}/apps")")"
APPS="$(ls "${DIRECTORY}/apps")"
structure="$(cat "${DIRECTORY}/data/categories/structure")"
#generate a virtual file system with apps in folders represented as subdirectories
PREIFS="$IFS"
IFS=$'\n'
vfiles=''
for app in $APPS
do
line="$(echo "$structure" | grep "$app"'|' | awk -F'|' '{print $2 "/" $1}')"
if [ -z "$line" ];then
echo "WARNING: $app app not found in $(echo "${DIRECTORY}/data/categories/structure" | sed 's+/home/pi+~+g') file." 1>&2
if [ -z "$onlinestructurefile" ];then
onlinestructurefile="$(wget -qO- 'https://raw.githubusercontent.com/Botspot/pi-apps/master/data/categories/structure')"
fi
onlinematch="$(echo "$onlinestructurefile" | grep "$app"'|')"
if [ ! -z "$onlinematch" ];then
echo -e "Located the default category for the $app app from github.\nIt is: ${onlinematch}EOO" 1>&2
echo "$onlinematch" >> "${DIRECTORY}/data/categories/structure"
else
echo -e "Could not find the default category for the $app app." 1>&2
echo "${app}|" >> "${DIRECTORY}/data/categories/structure"
fi
#refresh structure file
structure="$(cat "${DIRECTORY}/data/categories/structure")"
line="$(echo "$structure" | grep "$app"'|' | awk -F'|' '{print $2 "/" $1}')"
fi
vfiles="$vfiles
$line"
done
IFS="$PREIFS"
vfiles="$(echo "$vfiles" | grep . | sed 's+^/++g' | sort | uniq)"
#echo "$vfiles"
if [ ! -z "$prefix" ];then
echo "Showing apps within $prefix/" 1>&2
vfiles="$(echo "$vfiles" | grep "$prefix" | sed "s+$prefix/++g")"
fi
vfiles="$(echo "$vfiles" | sed 's+/.*+/+g' | sort | uniq)"
# only root file name replace \ with / move first / to end of line remove duplicate entries
#vfiles="$(echo "$vfiles" | awk -F '/' '{print $1}' | sed 's+\\+/+g' | sed 's+^/\(.*\)+\1/+' | sort | uniq)"
#echo "$vfiles" 1>&2
#get list of apps --------------- and exclude apps mentioned in hidelist file ---------------- remove lines containing '/'
APPS="$(echo "$vfiles" | grep -v '/')"
#get list of "directories"
DIRS="$(echo "$vfiles" | grep '/' | tr -d '/' | grep -vx "hidden")"
#APPS="$(ls "${DIRECTORY}/apps")"
#echo -e "Apps: $APPS\nDirs: $DIRS" 1>&2
#exit 0
#remove apps that are not compatible with OS architecture #remove apps that are not compatible with OS architecture
PREIFS="$IFS" PREIFS="$IFS"
IFS=$'\n' IFS=$'\n'
@ -96,17 +165,29 @@ if [ $reloadlist == 1 ];then
#shuffle the list if enabled #shuffle the list if enabled
if [ "$(cat "${DIRECTORY}/data/settings/Shuffle App list")" == 'Yes' ];then if [ "$(cat "${DIRECTORY}/data/settings/Shuffle App list")" == 'Yes' ];then
APPS="$(echo "$APPS" | shuf)" APPS="$(echo "$APPS" | shuf)"
DIRS="$(echo "$DIRS" | shuf)"
fi fi
if [ "$format" == yad ];then if [ "$format" == yad ];then
PREIFS="$IFS" PREIFS="$IFS"
IFS=$'\n' IFS=$'\n'
LIST='' LIST=''
for i in $DIRS
do
LIST="${LIST}${DIRECTORY}/icons/folder.png
${DIRECTORY}/icons/none-24.png
$i
$i/
App folder
"
done
for i in $APPS for i in $APPS
do do
LIST="$LIST$(echo "${DIRECTORY}/icons/$(cat "${DIRECTORY}/data/status/${i}" 2>/dev/null || echo "none").png") LIST="$LIST$(echo "${DIRECTORY}/icons/$(cat "${DIRECTORY}/data/status/${i}" 2>/dev/null || echo "none").png")
${DIRECTORY}/apps/${i}/icon-24.png ${DIRECTORY}/apps/${i}/icon-24.png
$i $i
$i
"\("$(cat "${DIRECTORY}/data/status/${i}" 2>/dev/null || echo "uninstalled")"\)" $(echo "$(cat "${DIRECTORY}/apps/${i}/description" || echo "Description unavailable")" | head -n1) "\("$(cat "${DIRECTORY}/data/status/${i}" 2>/dev/null || echo "uninstalled")"\)" $(echo "$(cat "${DIRECTORY}/apps/${i}/description" || echo "Description unavailable")" | head -n1)
" "
done done
@ -115,6 +196,12 @@ $i
PREIFS="$IFS" PREIFS="$IFS"
IFS=$'\n' IFS=$'\n'
LIST='' LIST=''
for i in $DIRS
do
LIST="$LIST
${i};${DIRECTORY}/icons/folder-64.png;${i}/"
done
for i in $APPS for i in $APPS
do do
LIST="$LIST LIST="$LIST
@ -125,21 +212,15 @@ ${i} "\("$(cat "${DIRECTORY}/data/status/${i}" 2>/dev/null || echo "uninstalled"
LIST="$(echo -e "$LIST")" LIST="$(echo -e "$LIST")"
#save entire list string to file for future use #save entire list string to file for future use
echo "$LIST" > "${DIRECTORY}/data/preload/LIST" echo "$LIST" > "$listfile"
export CACHED_LIST="$LIST" export CACHED_LIST="$LIST"
#save timestamps to file too #save timestamps to file too
mktimestamps mktimestamps
echo "$timestamps" > "${DIRECTORY}/data/preload/timestamps" echo "$timestamps" > "$timestampfile"
else else
if [ -z "$CACHED_LIST" ];then
echo "Reading list file..." 1>&2 echo "Reading list file..." 1>&2
LIST="$(cat "${DIRECTORY}/data/preload/LIST")" LIST="$(cat "$listfile")"
export CACHED_LIST="$LIST"
else
echo "Reading list variable..." 1>&2
LIST="$CACHED_LIST"
fi
fi fi
(#put icons in cache (#put icons in cache

@ -103,8 +103,9 @@ ${params}"
output="$(yad --center --title='Pi-Apps Settings' --width=310 --height=300 \ output="$(yad --center --title='Pi-Apps Settings' --width=310 --height=300 \
--form --separator='\n' --window-icon="${DIRECTORY}/icons/logo.png" --columns=2 \ --form --separator='\n' --window-icon="${DIRECTORY}/icons/logo.png" --columns=2 \
$tooltips \ $tooltips \
--field='New App'!"${DIRECTORY}/icons/create.png":FBTN "${DIRECTORY}/createapp" \ --field='Categories...'!"${DIRECTORY}/icons/categories.png":FBTN "bash -c '${DIRECTORY}/etc/categoryedit &>/dev/null'" \
$yadparams \ $yadparams \
--field='New App...'!"${DIRECTORY}/icons/create.png":FBTN "bash -c '${DIRECTORY}/createapp &>/dev/null'" \
--button='Reset'!"${DIRECTORY}/icons/backup.png"!'Reset all settings to their defaults':2 \ --button='Reset'!"${DIRECTORY}/icons/backup.png"!'Reset all settings to their defaults':2 \
--button=Cancel!"${DIRECTORY}/icons/exit.png":1 \ --button=Cancel!"${DIRECTORY}/icons/exit.png":1 \
--button=Save!"${DIRECTORY}/icons/check.png":0 \ --button=Save!"${DIRECTORY}/icons/check.png":0 \
@ -123,7 +124,7 @@ ${params}"
done done
#remove empty lines from $output #remove empty lines from $output
output="$(echo "$output" | sed -r '/^\s*$/d')" output="$(echo "$output" | grep .)"
echo "Output: ${output}EOO" echo "Output: ${output}EOO"

Loading…
Cancel
Save